#!/usr/bin/perl
#
# getQuote version 1.1
#
# A real simple Perl function to grab stock quotes from Yahoo!
#
# Return format (one line per symbol:
# Symbol,close,date,time,change $ - %,hi,low,volume
#
# http://www.ncc.com/freeware/
#
# Copyright (c) 1999-2002 by R. Steven Rainwater <rsr@ncc.com>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#==========================================================================
# History
#
# 03 Jul 2002 RSR Change HTTP string to 1.0 to simplify connection
#
use strict;
use Socket;

# Sample call to getquote. Add as many symbols as you like
print getQuote('DELL','RHAT','LNUX');

# function getQuote -- retrieves a quote from Yahoo!
sub getQuote {
    my $quote_server = 'quote.yahoo.com';
    my $quote_prefix = '/d/quotes.csv?s=';
    my $quote_suffix = '&f=sl1d1t1c0hgv&e=.csv';
    my $symbol_sep   = '+';
    my $result = '';

    # Get the first symbol
    my $request = $quote_prefix . shift;

    # Add additional symbols, if any
    foreach (@_) { $request .= $symbol_sep . $_; }
    $request .= $quote_suffix;

    # Make the connection
    my $iaddr = inet_aton($quote_server);
    my $paddr = sockaddr_in(80, $iaddr);
    socket(SOCKET, PF_INET, SOCK_STREAM, getprotobyname('tcp'));
    connect(SOCKET, $paddr) || die "Unable to connect $quote_server:80\n";
    select(SOCKET);
    $| = 1;
    select(STDOUT);
    
    # Send the request
    print SOCKET "GET $request HTTP/1.0\r\nHost: $quote_server:80\n\n";
    while(<SOCKET>) { $result .= $_ }
    close(SOCKET);

print "[$_]\n";

    # Parse and return the result
    $result =~ s/^.*\r\n\r\n//s;
    return $result;
}
